
#ifndef __BASEWINDOW_H__
#define __BASEWINDOW_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include "documentview.h"
#include "searchentry.h"

G_BEGIN_DECLS


#define TYPE_BASE_WINDOW (base_window_get_type ())
#define BASE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_WINDOW, BaseWindow))
#define BASE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_WINDOW, BaseWindowClass))
#define IS_BASE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_WINDOW))
#define IS_BASE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_WINDOW))
#define BASE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_WINDOW, BaseWindowClass))

typedef struct _BaseWindow BaseWindow;
typedef struct _BaseWindowClass BaseWindowClass;
typedef struct _BaseWindowPrivate BaseWindowPrivate;

struct _BaseWindow {
	GtkWindow parent;
	BaseWindowPrivate * priv;
	GtkScrolledWindow* scrolled_window;
	DocumentView* document_view;
	GtkUIManager* ui_manager;
};
struct _BaseWindowClass {
	GtkWindowClass parent;
	gboolean (*is_document) (BaseWindow* self, char* uri);
};

GtkClipboard* base_window_get_clipboard ();
gboolean base_window_is_document (BaseWindow* self, char* uri);
gboolean base_window_save_scroll_position (BaseWindow* self);
void base_window_restore_scroll_position (BaseWindow* self);
void base_window_setup_ui_manager (BaseWindow* self);
void base_window_update_menu_state (BaseWindow* self);
void base_window_connect_base_events (BaseWindow* self);
void base_window_populate_base_window (BaseWindow* self);
GType base_window_get_type ();

G_END_DECLS

#endif
