
#ifndef __DOCUMENT_H__
#define __DOCUMENT_H__

#include <glib.h>
#include <glib-object.h>
#include <gtksourceview/gtksourcebuffer.h>
#include <stdlib.h>
#include <string.h>
#include "metadata.h"

G_BEGIN_DECLS


#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;
typedef struct _DocumentPrivate DocumentPrivate;

struct _Document {
	GtkSourceBuffer parent;
	DocumentPrivate * priv;
};
struct _DocumentClass {
	GtkSourceBufferClass parent;
};

Document* document_new (char* uri);
gboolean document_open (Document* self);
void document_save (Document* self);
char* document_get_file_name (Document* self);
char* document_get_mimetype (Document* self);
char* document_get_folder (Document* self);
char* document_get_basename (Document* self);
char* document_get_title_string (Document* self);
char* document_uri_to_filename (char* uri);
MetadataManager* document_get_metadata (Document* self);
void document_set_metadata (Document* self, MetadataManager* value);
GType document_get_type ();

G_END_DECLS

#endif
