
#ifndef __METADATA_H__
#define __METADATA_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define TYPE_METADATA_MANAGER (metadata_manager_get_type ())
#define METADATA_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_MANAGER, MetadataManager))
#define METADATA_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_MANAGER, MetadataManagerClass))
#define IS_METADATA_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_MANAGER))
#define IS_METADATA_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_MANAGER))
#define METADATA_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_MANAGER, MetadataManagerClass))

typedef struct _MetadataManager MetadataManager;
typedef struct _MetadataManagerClass MetadataManagerClass;
typedef struct _MetadataManagerPrivate MetadataManagerPrivate;

struct _MetadataManager {
	GObject parent;
	MetadataManagerPrivate * priv;
};
struct _MetadataManagerClass {
	GObjectClass parent;
};

MetadataManager* metadata_manager_new (char* hash);
char* metadata_manager_get (MetadataManager* self, char* key);
int metadata_manager_get_int (MetadataManager* self, char* key);
long metadata_manager_get_long (MetadataManager* self, char* key);
void metadata_manager_set (MetadataManager* self, char* key, char* value);
void metadata_manager_write (MetadataManager* self);
GType metadata_manager_get_type ();

G_END_DECLS

#endif
