
#ifndef __SEARCHENTRY_H__
#define __SEARCHENTRY_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

G_BEGIN_DECLS


#define TYPE_SEARCH_EVENT_ARGS (search_event_args_get_type ())
#define SEARCH_EVENT_ARGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_EVENT_ARGS, SearchEventArgs))
#define SEARCH_EVENT_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_EVENT_ARGS, SearchEventArgsClass))
#define IS_SEARCH_EVENT_ARGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_EVENT_ARGS))
#define IS_SEARCH_EVENT_ARGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_EVENT_ARGS))
#define SEARCH_EVENT_ARGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_EVENT_ARGS, SearchEventArgsClass))

typedef struct _SearchEventArgs SearchEventArgs;
typedef struct _SearchEventArgsClass SearchEventArgsClass;
typedef struct _SearchEventArgsPrivate SearchEventArgsPrivate;

#define TYPE_SEARCH_ENTRY (search_entry_get_type ())
#define SEARCH_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_ENTRY, SearchEntry))
#define SEARCH_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_ENTRY, SearchEntryClass))
#define IS_SEARCH_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_ENTRY))
#define IS_SEARCH_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_ENTRY))
#define SEARCH_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_ENTRY, SearchEntryClass))

typedef struct _SearchEntry SearchEntry;
typedef struct _SearchEntryClass SearchEntryClass;
typedef struct _SearchEntryPrivate SearchEntryPrivate;

struct _SearchEventArgs {
	GObject parent;
	SearchEventArgsPrivate * priv;
	gboolean backwards;
	gboolean next_result;
	char* search_text;
};
struct _SearchEventArgsClass {
	GObjectClass parent;
};
/* this can't be public yet due to a vala ordering bug*/
struct _SearchEntry {
	GtkEntry parent;
	SearchEntryPrivate * priv;
};
struct _SearchEntryClass {
	GtkEntryClass parent;
};
typedef enum  {
	SEARCH_MODE_SILENT,
	SEARCH_MODE_TEXT,
	SEARCH_MODE_GO_TO_LINE,
	SEARCH_MODE_REPLACE,
} SearchMode;

SearchMode search_event_args_get_mode (SearchEventArgs* self);
void search_event_args_set_mode (SearchEventArgs* self, SearchMode value);
GType search_event_args_get_type ();
SearchEntry* search_entry_new (GtkLabel* lbl);
char* search_entry_get_last_search (SearchEntry* self);
char* search_entry_get_last_replace (SearchEntry* self);
void search_entry_set_maxlines (SearchEntry* self, int lines);
void search_entry_set_mode (SearchEntry* self, SearchMode new_mode);
GType search_entry_get_type ();

G_END_DECLS

#endif
