
#include "uimanager.h"
#include <stdlib.h>
#include <string.h>
#include "settings.h"

struct _CustomUIManagerPrivate {
	GtkActionGroup* action_group;
	GtkActionGroup* document_action_group;
};
#define CUSTOM_UI_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CUSTOM_UI_MANAGER, CustomUIManagerPrivate))
enum  {
	CUSTOM_UI_MANAGER_DUMMY_PROPERTY,
};
static GObject * custom_ui_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void custom_ui_manager_dispose (GObject * obj);

static GObject * custom_ui_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties)
{
	GObject * obj;
	CustomUIManagerClass * klass;
	GObjectClass * parent_class;
	klass = CUSTOM_UI_MANAGER_CLASS (g_type_class_peek (TYPE_CUSTOM_UI_MANAGER));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	CustomUIManager * self = CUSTOM_UI_MANAGER (obj);
	{
		GtkToggleAction* ta = NULL;
		GtkActionGroup* __temp0 = NULL;
		self->priv->action_group = (__temp0 = gtk_action_group_new ("general"), (self->priv->action_group == NULL ? NULL : (self->priv->action_group = (g_object_unref (self->priv->action_group), NULL))), __temp0);
		GtkActionGroup* __temp1 = NULL;
		self->priv->document_action_group = (__temp1 = gtk_action_group_new ("document"), (self->priv->document_action_group == NULL ? NULL : (self->priv->document_action_group = (g_object_unref (self->priv->document_action_group), NULL))), __temp1);
		GtkAction* __temp2 = NULL;
		gtk_action_group_add_action (self->priv->action_group, (__temp2 = gtk_action_new ("file", "_File", NULL, NULL)));
		(__temp2 == NULL ? NULL : (__temp2 = (g_object_unref (__temp2), NULL)));
		GtkAction* __temp3 = NULL;
		gtk_action_group_add_action (self->priv->action_group, (__temp3 = gtk_action_new ("edit", "_Edit", NULL, NULL)));
		(__temp3 == NULL ? NULL : (__temp3 = (g_object_unref (__temp3), NULL)));
		GtkAction* __temp4 = NULL;
		gtk_action_group_add_action (self->priv->document_action_group, (__temp4 = gtk_action_new ("tags", "_Tags", NULL, NULL)));
		(__temp4 == NULL ? NULL : (__temp4 = (g_object_unref (__temp4), NULL)));
		GtkAction* __temp5 = NULL;
		gtk_action_group_add_action (self->priv->action_group, (__temp5 = gtk_action_new ("view", "_View", NULL, NULL)));
		(__temp5 == NULL ? NULL : (__temp5 = (g_object_unref (__temp5), NULL)));
		GtkAction* __temp6 = NULL;
		gtk_action_group_add_action (self->priv->action_group, (__temp6 = gtk_action_new ("document", "_Document", NULL, NULL)));
		(__temp6 == NULL ? NULL : (__temp6 = (g_object_unref (__temp6), NULL)));
		GtkAction* __temp7 = NULL;
		gtk_action_group_add_action (self->priv->action_group, (__temp7 = gtk_action_new ("help", "_Help", NULL, NULL)));
		(__temp7 == NULL ? NULL : (__temp7 = (g_object_unref (__temp7), NULL)));
		/* File menu */
		GtkAction* __temp8 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->action_group, (__temp8 = gtk_action_new ("close", NULL, "Close this document", "gtk-close")), "<ctrl>w");
		(__temp8 == NULL ? NULL : (__temp8 = (g_object_unref (__temp8), NULL)));
		GtkAction* __temp9 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->action_group, (__temp9 = gtk_action_new ("open-folder", "_Open Folder", "Open the folder containing this document", "gtk-open")), "<ctrl>o");
		(__temp9 == NULL ? NULL : (__temp9 = (g_object_unref (__temp9), NULL)));
		/* Edit menu */
		GtkAction* __temp10 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp10 = gtk_action_new ("undo", NULL, "Undo the last action", "gtk-undo")), "<ctrl>z");
		(__temp10 == NULL ? NULL : (__temp10 = (g_object_unref (__temp10), NULL)));
		GtkAction* __temp11 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp11 = gtk_action_new ("redo", NULL, "Redo the last action", "gtk-redo")), "<shift><ctrl>z");
		(__temp11 == NULL ? NULL : (__temp11 = (g_object_unref (__temp11), NULL)));
		GtkAction* __temp12 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp12 = gtk_action_new ("cut", NULL, "Cut the selection or current line", "gtk-cut")), "<ctrl>x");
		(__temp12 == NULL ? NULL : (__temp12 = (g_object_unref (__temp12), NULL)));
		GtkAction* __temp13 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp13 = gtk_action_new ("copy", NULL, "Copy the selection or current line", "gtk-copy")), "<ctrl>c");
		(__temp13 == NULL ? NULL : (__temp13 = (g_object_unref (__temp13), NULL)));
		GtkAction* __temp14 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp14 = gtk_action_new ("paste", NULL, "Paste the clipboard", "gtk-paste")), "<ctrl>v");
		(__temp14 == NULL ? NULL : (__temp14 = (g_object_unref (__temp14), NULL)));
		GtkAction* __temp15 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp15 = gtk_action_new ("block-cut", "_Block Cut", "Cut the selected block", "gtk-cut")), "<shift><ctrl>x");
		(__temp15 == NULL ? NULL : (__temp15 = (g_object_unref (__temp15), NULL)));
		GtkAction* __temp16 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp16 = gtk_action_new ("block-copy", "Bl_ock Copy", "Copy the selected block", "gtk-copy")), "<shift><ctrl>c");
		(__temp16 == NULL ? NULL : (__temp16 = (g_object_unref (__temp16), NULL)));
		GtkAction* __temp17 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp17 = gtk_action_new ("new-line", "Insert _New Line", "Insert a new line below the active line", NULL)), "<ctrl>Return");
		(__temp17 == NULL ? NULL : (__temp17 = (g_object_unref (__temp17), NULL)));
		GtkAction* __temp18 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp18 = gtk_action_new ("find", "_Find...", "Search for text", "gtk-find")), "<ctrl>f");
		(__temp18 == NULL ? NULL : (__temp18 = (g_object_unref (__temp18), NULL)));
		GtkAction* __temp19 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp19 = gtk_action_new ("replace", "_Replace...", "Replace all tags", "gtk-find-and-replace")), "<ctrl>r");
		(__temp19 == NULL ? NULL : (__temp19 = (g_object_unref (__temp19), NULL)));
		GtkAction* __temp20 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp20 = gtk_action_new ("goto-line", "Go to _Line...", "Go to a specific line", "gtk-jump-to")), "<ctrl>l");
		(__temp20 == NULL ? NULL : (__temp20 = (g_object_unref (__temp20), NULL)));
		GtkAction* __temp21 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp21 = gtk_action_new ("select-all", "Select _All", "Select the entire document", "gtk-select-all")), "<ctrl>a");
		(__temp21 == NULL ? NULL : (__temp21 = (g_object_unref (__temp21), NULL)));
		/* Tags submenu */
		GtkAction* __temp22 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp22 = gtk_action_new ("tag-add", "_Tag Selection", "Tag the current selection", NULL)), "<ctrl>t");
		(__temp22 == NULL ? NULL : (__temp22 = (g_object_unref (__temp22), NULL)));
		GtkAction* __temp23 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp23 = gtk_action_new ("tag-add-and-search", "Tag and _Find Next", "Tag the current selection and find a similar one", NULL)), "<ctrl>g");
		(__temp23 == NULL ? NULL : (__temp23 = (g_object_unref (__temp23), NULL)));
		GtkAction* __temp24 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp24 = gtk_action_new ("tag-remove", "_Remove Tags", "Remove all tags under current selection or entire document", NULL)), "<shift><ctrl>t");
		(__temp24 == NULL ? NULL : (__temp24 = (g_object_unref (__temp24), NULL)));
		GtkAction* __temp25 = NULL;
		gtk_action_group_add_action_with_accel (self->priv->document_action_group, (__temp25 = gtk_action_new ("tag-search", "Tag _Search Results", "Tag all matches from last search", NULL)), "<shift><ctrl>f");
		(__temp25 == NULL ? NULL : (__temp25 = (g_object_unref (__temp25), NULL)));
		/* View menu */
		GtkToggleAction* __temp26 = NULL;
		ta = (__temp26 = gtk_toggle_action_new ("line-numbers", "_Line Numbers", "Toggle display of line numbers", NULL), (ta == NULL ? NULL : (ta = (g_object_unref (ta), NULL))), __temp26);
		gtk_toggle_action_set_active (ta, settings_get_show_line_numbers ());
		gtk_action_group_add_action (self->priv->action_group, GTK_ACTION (ta));
		GtkToggleAction* __temp27 = NULL;
		ta = (__temp27 = gtk_toggle_action_new ("margin", "Right _Margin", "Toggle display of 80 character margin", NULL), (ta == NULL ? NULL : (ta = (g_object_unref (ta), NULL))), __temp27);
		gtk_toggle_action_set_active (ta, settings_get_show_margin ());
		gtk_action_group_add_action (self->priv->action_group, GTK_ACTION (ta));
		/* Document menu */
		GtkToggleAction* __temp28 = NULL;
		ta = (__temp28 = gtk_toggle_action_new ("word-wrap", "_Word Wrap", "Enable or disable text wrapping", NULL), (ta == NULL ? NULL : (ta = (g_object_unref (ta), NULL))), __temp28);
		gtk_toggle_action_set_active (ta, FALSE);
		gtk_action_group_add_action (self->priv->document_action_group, GTK_ACTION (ta));
		/* Help menu */
		GtkAction* __temp29 = NULL;
		gtk_action_group_add_action (self->priv->action_group, (__temp29 = gtk_action_new ("about", NULL, "About this application", "gtk-about")));
		(__temp29 == NULL ? NULL : (__temp29 = (g_object_unref (__temp29), NULL)));
		gtk_ui_manager_insert_action_group (GTK_UI_MANAGER (self), self->priv->action_group, 0);
		gtk_ui_manager_insert_action_group (GTK_UI_MANAGER (self), self->priv->document_action_group, 0);
		(ta == NULL ? NULL : (ta = (g_object_unref (ta), NULL)));
	}
	return obj;
}


static void custom_ui_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec)
{
	CustomUIManager * self = CUSTOM_UI_MANAGER (object);
	switch (property_id) {
	}
}


static void custom_ui_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec)
{
	CustomUIManager * self = CUSTOM_UI_MANAGER (object);
	switch (property_id) {
	}
}


static void custom_ui_manager_class_init (CustomUIManagerClass * klass)
{
	g_type_class_add_private (klass, sizeof (CustomUIManagerPrivate));
	G_OBJECT_CLASS (klass)->get_property = custom_ui_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = custom_ui_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = custom_ui_manager_constructor;
	G_OBJECT_CLASS (klass)->dispose = custom_ui_manager_dispose;
}


static void custom_ui_manager_init (CustomUIManager * self)
{
	self->priv = CUSTOM_UI_MANAGER_GET_PRIVATE (self);
}


static void custom_ui_manager_dispose (GObject * obj)
{
	CustomUIManager * self = CUSTOM_UI_MANAGER (obj);
	(self->priv->action_group == NULL ? NULL : (self->priv->action_group = (g_object_unref (self->priv->action_group), NULL)));
	(self->priv->document_action_group == NULL ? NULL : (self->priv->document_action_group = (g_object_unref (self->priv->document_action_group), NULL)));
	CustomUIManagerClass * klass;
	GObjectClass * parent_class;
	klass = CUSTOM_UI_MANAGER_CLASS (g_type_class_peek (TYPE_CUSTOM_UI_MANAGER));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	parent_class->dispose (obj);
}


GType custom_ui_manager_get_type ()
{
	static GType g_define_type_id = 0;
	if (G_UNLIKELY (g_define_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (CustomUIManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) custom_ui_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CustomUIManager), 0, (GInstanceInitFunc) custom_ui_manager_init };
		g_define_type_id = g_type_register_static (GTK_TYPE_UI_MANAGER, "CustomUIManager", &g_define_type_info, 0);
	}
	return g_define_type_id;
}



